#!/usr/bin/perl
#
# playalbum.cgi
#
# play album with some options
#
# imports:
#  settings:
#    TUNEBOT_ROOT    root of tunebot installation.
#    TUNEIX          index of tune files.
#    TUNETAGS        index of tune attributes.
#    BANNER_STRING   identifying string for web page titles
#  environment:
#    QUERY_STRING    string from the browser
#  files:
#    $TUNEBOT_ROOT/tune.autotags
#    $TUNEBOT_ROOT/html/bodypart.html.head
#    $TUNEBOT_ROOT/html/bodypart.html.tail
#

########################################################################
# perl script boilerplate.
# set tunebot root and load utility module.
#
BEGIN {
    $tunebot_root="XXX-the-tunebot-install-root";
    @INC=($tunebot_root."/lib", @INC);
}
use Tunebot;
#
# end of perl boilerplate
########################################################################

$cgibinurl=$configs{"CGI_BIN_URL"};
$topurl=$configs{"HTML_TOP_URL"};

$debug=0;

print "Content-type: text/html\n";
print "\n";

Tunebot::suckInPostGet;

if ($posts{"commit"} ne "") {
    $album=Tunebot::urldecode($posts{"album"});
#    print "<pre>\n";
#    print "album is $album \n";
    if ($posts{"all"} eq "") {
	$album=$album . ":";
	foreach $i (%posts) {
	    if ($i =~ /^t[0-9]/) {
		$i =~ s/^t//;
		$album=$album . $i . ",";
	    }
	}
    }
#    print $album . "\n";
#    print "</pre>\n";
    print "<html>\n";
    print "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
    print "<META HTTP-EQUIV=REFRESH CONTENT=\"0; URL=tuneput.cgi?album=" . $album . "\">";
    print "</html>\n";

} else {
    Tunebot::suckInTags;
    Tunebot::suckInAutotags;
#
# render selection form.
#
    print "<html>\n";
    print "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
    print "<head>\n";
    print "<title>" . $configs{BANNER_STRING} . " Play Album</title>\n";
    print "</head>\n";
    open(I, $tunebot_root . "/html/bodypart.html.head");
    while ($line = <I>) {
	print $line;
    }
    close(I);
    print "<p>\n";
    print "<center><font size=+2><b>" . $configs{BANNER_STRING} . " Play Album</b></font></center>\n";
    print "<p>\n";

    $album=$posts{"album"};
    if ($album ne "") {
	$album=Tunebot::urldecode($album);
        print "<font size=+1><b>" . Tunebot::friendlyAlbumTitle($album). "</b></font>\n<p>\n";
	$nt = 0;
	$l=length($album);
	open(TUNEIX, $configs{TUNEIX});
	while ($line = <TUNEIX>) {
	    chop $line;
	    if (substr($line, 0, $l) eq $album) {
		$line =~ s/\.mp3$//;
		$tracks[$nt] = $line;
		$nt++;
	    }
	}
	close(TUNEIX);
	@tracks = sort(@tracks);
	print "<form action=\"$cgibinurl/playalbum.cgi\">\n";
	print "Select the tracks you want to play and hit the play button\n";
	print "<p>\n";
	print "<input type=hidden name=album value=$album>\n";
	print "<input type=hidden name=commit>\n";
	print "<table cellpadding=0 cellspacing=0 align=center width=90%>\n";
	print "<tr><td><input type=image border=0 align=middle src=\"$topurl/play.gif\" alt=\"Play\"></td></tr>\n";
	for ($i = 0; $i <= $#tracks; $i++) {
	    $t = $tracks[$i];
	    $t = $tags{$t, "N"};
	    print "<tr><td width=10%><input type=checkbox name=t", $i + 1, "></td>";
	    print "<td><font size=-1>", $i + 1, ". </font> ", $t, "</td></tr>\n";
	}
	print "<tr><td width=10%><input type=checkbox name=all></td>";
	print "<td>(play all tracks)</td></tr>\n";
	print "</table>\n";
	print "</form>\n";
    }
}

open(I, $tunebot_root . "/html/bodypart.html.tail");
while ($line = <I>) {
    print $line;
}
close(I);

print "</html>\n";
exit 0

