#!/usr/bin/perl
#
# search.cgi
#
# search for song tracks by title or artist
#
# imports:
#  settings:
#    TUNEBOT_ROOT    root of tunebot installation.
#    TUNEIX          index of tune files.
#    TUNETAGS        index of tune attributes.
#    BANNER_STRING   identifying string for web page titles
#  environment:
#    QUERY_STRING    string from the browser
#  files:
#    $TUNEBOT_ROOT/tune.autotags
#    $TUNEBOT_ROOT/html/bodypart.html.head
#    $TUNEBOT_ROOT/html/bodypart.html.tail
#

########################################################################
# perl script boilerplate.
# set tunebot root and load utility module.
#
BEGIN {
    $tunebot_root="XXX-the-tunebot-install-root";
    @INC=($tunebot_root."/lib", @INC);
}
use Tunebot;
#
# end of perl boilerplate
########################################################################

$cgibinurl=$configs{"CGI_BIN_URL"};
$topurl=$configs{"HTML_TOP_URL"};

$debug=0;

sub gettime {
    my ($i) = $tags{@_, "T"};
    if ($i eq "") {
	$i = "?";
    }
    $i = "(" . $i . ")";
    return $i;
}

print "Content-type: text/html\n";
print "\n";
print "<html>\n";
print "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
print "<head>\n";
print "<title>" . $configs{BANNER_STRING} . " Search</title>\n";
print "</head>\n";
open(I, $tunebot_root . "/html/bodypart.html.head");
while ($line = <I>) {
    print $line;
}
close(I);

Tunebot::suckInPostGet;

#
# render search command form.
#
print "<p>\n";
print "<center><font size=+2><b>" . $configs{BANNER_STRING} . " Searcheroo</b></font></center>\n";
print "<p>\n";
print "<form action=\"$cgibinurl/search.cgi\">\n";
print "<b>Find Song Titles with: </b> ";
if ($posts{"titlepat"} ne "") {
    print "<input align=middle name=titlepat type=text value=\"" . $posts{titlepat} . "\">\n";
} else {
    print "<input align=middle name=titlepat type=text>\n";
}
#print " <input name=dotitle type=image src=\"$topurl/readthis.gif\" alt=\"Do Search\" align=center border=0>\n";
print "</form>\n";
print "<p>\n";
print "<form action=\"$cgibinurl/search.cgi\">\n";
print "<b>Find with Artist Name: </b> ";
if ($posts{"artistpat"} ne "") {
    print "<input align=middle name=artistpat type=text value=\"" . $posts{artistpat} . "\">\n";
} else {
    print "<input align=middle name=artistpat type=text>\n";
}
print "</form>\n";

#
# for sorting upper and lowercase together
#
sub folded { uc($a) cmp uc($b); }

#
# do actual search, if we were called with form data
# this is the by-track-title search.
#
print "<p>\n";
print "<hr>\n";
if ($posts{"titlepat"} ne "") {
    Tunebot::suckInTags();
    Tunebot::suckInAutotags();
    $re = $posts{titlepat};
    $re =~ tr/A-Z/a-z/;
    open(I, $configs{TUNEIX});
    $x = 1;
    while ($path = <I>) {
	chop $path;
	$path =~ s/\.mp3$//;
	$n = $tags{$path, "N"};
	$n =~ tr/A-Z/a-z/;
	if ($n =~ $re) {
	    $sortk{$tags{$path, "N"} . "\t$x"} = $path;
	    $x++;
	}
    }
    close(I);

    if ($x == 1) {
	print "<center>No matches were found</center>\n";
    } else {
	print "<center>Click to play song.  Artist and album names take you to the index.</center>\n";
	print "<p><table width=90%>\n";
	$x = 1;
	foreach $sk (sort folded keys %sortk) {
	    $path = $sortk{$sk};
	    print "<tr><td width=10%>" . $x . ".</td>";
	    print "<td width=60%>" . Tunebot::friendlyTrackTitle($path, 1) . "</td>";
	    $time = gettime($path);
	    print "<td><a href=\"$cgibinurl/abouttrack.cgi?$path.mp3\">" . gettime($path). "</a> $host</td>\n";
	    print "</tr>\n";
	    $x++;
	}
	print "</table>\n";
    }
}

if ($posts{"artistpat"} ne "") {
    Tunebot::suckInTags();
    Tunebot::suckInAutotags();
    $re = $posts{artistpat};
    $re =~ tr/A-Z/a-z/;
    open(I, $configs{TUNEIX});
    $x = 1;
    while ($path = <I>) {
	chop $path;
	$path =~ s/\.mp3$//;
	$a = $tags{$path, "ARTIST"};
	$a =~ tr/A-Z/a-z/;
#
# test ARTIST tag of track,
# then artist directory level Name,
# then album level ARTIST tag.
#
	if ($a =~ $re) {
	    $sortk{$tags{$path, "N"} . "\t$x"} = $path;
	    $x++;
	} else {
	    $apath = $path;
	    $apath =~ s/\/[^\/]*\/[^\/]*$//;
	    $a = $tags{$apath, "N"};
	    $a =~ tr/A-Z/a-z/;
	    if ($a =~ $re) {
		$sortk{$tags{$path, "N"} . "\t$x"} = $path;
		$x++;
	    } else {
		$apath = $path;
		$apath =~ s/\/[^\/]*$//;
		$a = $tags{$apath, "ARTIST"};
		$a =~ tr/A-Z/a-z/;
		if ($a =~ $re) {
		    $sortk{$tags{$path, "N"} . "\t$x"} = $path;
		    $x++;
		}
	    }
	}
    }
    close(I);

    if ($x == 1) {
	print "<center>No matches were found</center>\n";
    } else {
	print "<center>Click to play song.  Artist and album names take you to the index.</center>\n";
	print "<p><table width=90%>\n";
	$x = 1;
	foreach $sk (sort folded keys %sortk) {
	    $path = $sortk{$sk};
	    print "<tr><td width=10%>" . $x . ".</td>";
	    print "<td width=60%>" . Tunebot::friendlyTrackTitle($path, 1) . "</td>";
	    $time = gettime($path);
	    print "<td><a href=\"$cgibinurl/abouttrack.cgi?$path.mp3\">" . gettime($path). "</a> $host</td>\n";
	    print "</tr>\n";
	    $x++;
	}
	print "</table>\n";
    }
}

open(I, $tunebot_root . "/html/bodypart.html.tail");
while ($line = <I>) {
    print $line;
}
close(I);

print "</html>\n";
exit 0

