#!/usr/bin/perl
#
# enter a dedication for a request
#
# imports:
#    environment:
#    TUNEBOT_ROOT    root of tunebot installation.
#    QDIR            directory where requests and play history live.
#    BANNER_STRING   identifying string for web page titles
#
#    files:
#       $TUNEBOT_ROOT/tune.autotags
#       $TUNEBOT_ROOT/html/bodypart.html.head
#       $TUNEBOT_ROOT/html/bodypart.html.tail
#

########################################################################
# perl script boilerplate.
# set tunebot root and load utility module.
#
BEGIN {
    $tunebot_root="XXX-the-tunebot-install-root";
    @INC=($tunebot_root."/lib", @INC);
}
use Tunebot;
#
# end of perl boilerplate
########################################################################

$cgibinurl=$configs{"CGI_BIN_URL"};

$q_directory=$configs{QDIR};
$debug=0;

Tunebot::suckInTags;
Tunebot::suckInAutotags;

sub gettime {
    my ($i) = Tunebot::lookupTagInFile(@_, "T=");
    if ($i eq "") {
	$i = "?";
    }
    $i = "(" . $i . ")";
    return $i;
}

print "Content-type: text/html\n";
print "\n";
print "<html>\n";
print "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
print "<head>\n";
print "<title>" . $ENV{BANNER_STRING} . " Edit Dedication</title>\n";
print "</head>\n";
open(I, $tunebot_root . "/html/bodypart.html.head");
while ($line = <I>) {
    print $line;
}
close(I);
print "<center><font size=+2><b>" . $ENV{BANNER_STRING} . " Dedication</b></font></center><p>\n";

if ($debug > 0) {
    print "<p>\n";
    print "query string is: " . $ENV{QUERY_STRING} . "\n";
    print "<p>\n";
    print "i've got " . $#ARGV . " command args\n";
    for ($i = 0; $i <= $#ARGV; $i++) {
	print "<br>" . $i . ". " . @ARGV[$i] . "\n";
    }
    print "<p>\n";
    print "<pre>\n";
}
#
# parse stdin into a list of name-value pairs and stuff into hash %posts.
# this is used to support the POST method.
# stdin format is "name1=value1&name2=value2&...".
#
while ($line = <>) {
    chop $line;
    @nvpairs = split('&', $line);
    for ($i = 0; $i <= $#nvpairs; $i++) {
	@nv = split('=',@nvpairs[$i]);
	if ($#nv == 1) {
	    if ($debug > 0) {
		print @nv[0] . "  =  " . @nv[1] . "\n";
	    }
	    $posts{@nv[0]} = @nv[1];
	}
    }
};
#
# parse QUERY_STRING into nv pairs and hash them.
# this supports the GET method (which is currently used).
#
@nvpairs = split('&', $ENV{QUERY_STRING});
for ($i = 0; $i <= $#nvpairs; $i++) {
    @nv = split('=',@nvpairs[$i]);
    if ($#nv == 1) {
	if ($debug > 0) {
	    print @nv[0] . "  =  " . @nv[1] . "\n";
	}
	$posts{@nv[0]} = @nv[1];
    }
}
if ($debug > 0) {
    print "</pre>\n";
}

$msg = $posts{dedmess};
$qitem = $posts{qitem};
$showit = 0;
if ($qitem eq "") {
    $qitem = $ENV{QUERY_STRING};
    if ( -f "$q_directory/$qitem" ) {
	$msg = Tunebot::lookupTagInFile("$q_directory/$qitem", "DEDICATION=");
	$showit = 1;
    } else {
	print "Sorry, there is no such request.\n";
    }
} else {
#   $msg =~ tr/+/ /;
    $msg = Tunebot::urldecode($msg);
    $qitem = $posts{qitem};
    if ( -f "$q_directory/$qitem" ) {
	open(I, "$q_directory/$qitem");
	open(O, ">$q_directory/$qitem.tmp");
	while ($line = <I>) {
	    if ($line !~ /^DEDICATION=/) {
		print O $line;
	    }
	}
	if ($msg ne "") {
	    print O "DEDICATION=$msg\n";
	}
	close(I);
	close(O);
	rename "$q_directory/$qitem.tmp", "$q_directory/$qitem";
	$showit = 1;
    } else {
	print "Sorry, there is no such request.\n";
    }
}

if ($showit == 1) {
    print "<p><table width=90%>\n";
    print "<tr><td colspan=2><hr></td></tr>\n";
    $type = Tunebot::lookupTagInFile($q_directory . "/" . $qitem, "TYPE=");
    $path = Tunebot::lookupTagInFile($q_directory . "/" . $qitem, "Q=");
    $host = Tunebot::lookupTagInFile($q_directory . "/" . $qitem, "HOSTNAME=");
    $dedic = Tunebot::lookupTagInFile($q_directory . "/" . $qitem, "DEDICATION=");
    if ($dedic ne "") {
	$dedic = "<br><font color=gold>" . $dedic . "</font>";
    }
    if (!($host =~ /^[0-9]/)) {
	$host =~ s/\..*//;
    }
    if ($type eq "ALBUM") {
	$title = Tunebot::friendlyAlbumTitle($path);
	$time = "TotalTime";
	$trk = Tunebot::lookupTagInFile($q_directory . "/" . $qitem, "CTRACK=");
	print "<tr>\n";
	print "<td width=60%><font size=+1><b>$title</b></font>\n";
	if ($trk ne "") {
	    print "<br>&nbsp; <em>(playing track $trk)</em>";
	}
	print "</td>\n";
	print "<td>($time) $host $dedic</td>\n";
	print "</tr>\n";
    } else {
	$path =~ s/\.mp3$//;
	$title = Tunebot::friendlyTrackTitle($path);
	$time = gettime($path);
	print "<tr>\n";
	print "<td width=60%>$title</td>\n";
	print "<td><a href=\"$cgibinurl/abouttrack.cgi?$path\">$time</a> $host $dedic</td>\n";
	print "</tr>\n";
    }
    print "<tr><td colspan=2><hr></td></tr>\n";
    print "</table>\n";

    print "<p>\n";
    print "<form action=\"$cgibinurl/tuneded.cgi\">\n";
    print "Dedication Message: ";
    print "<input type=text name=dedmess value=\"" . $msg . "\">\n";
    print "<input type=hidden name=qitem value=\"" . $qitem . "\">\n";
    print "</form>\n";
}

open(I, $tunebot_root . "/html/bodypart.html.tail");
while ($line = <I>) {
    print $line;
}
close(I);

print "</html>\n";
exit 0

